////////////////////////////////////////////////////////////////////////
// channels_widget.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.channels_widget")

// <%pre>
#line 1 "channels_widget.ecpp"


#include <exception.h>
#include <setup.h>

#if VDRVERSNUM < 20300
#include <tools.h>  // ReadLock
#endif

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("channels_widget");

static const char* rawData = "0\000\000\0001\000\000\000\?\000\000\000E\000\000\000G\000\000\000I\000\000\000Z\000\000"
  "\000[\000\000\000\134\000\000\000^\000\000\000h\000\000\000r\000\000\000\n<select name=\"\" id=\"\" >\n\t\t<option va"
  "lue=\"\">: </option>\n</select>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("channels_widget " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string name = qparam.get< std::string >("name", ( "channel"));
std::string selected = qparam.get< std::string >("selected");
std::string onchange = qparam.get< std::string >("onchange");
bool channelid = qparam.get< bool >("channelid", ( false));
  // </%args>

#line 20 "channels_widget.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
  // <%cpp>
#line 22 "channels_widget.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

  reply.out() << _tntChunks[0]; // \n
#line 25 "channels_widget.ecpp"

#if VDRVERSNUM >= 20301
	LOCK_CHANNELS_READ;
#else
	ReadLock channelsLock( Channels );
	if ( !channelsLock )
		throw HtmlError( tr("Couldn't aquire access to channels, please try again later.") );
#endif

  reply.out() << _tntChunks[1]; // <select name="
#line 34 "channels_widget.ecpp"
  reply.sout() << ( name );
  reply.out() << _tntChunks[2]; // " id="
#line 34 "channels_widget.ecpp"
  reply.sout() << ( name );
  reply.out() << _tntChunks[3]; // " 
#line 34 "channels_widget.ecpp"
 reply.out() << ( !onchange.empty() ? "onchange=\""+onchange+"\"" : "" ); 
  reply.out() << _tntChunks[4]; // >\n
#line 35 "channels_widget.ecpp"
#if VDRVERSNUM >= 20301

#line 36 "channels_widget.ecpp"
	for ( cChannel *listChannel = (cChannel *)Channels->First(); listChannel; listChannel = (cChannel *)Channels->Next( listChannel ) ) {

#line 37 "channels_widget.ecpp"
#else

#line 38 "channels_widget.ecpp"
	for ( cChannel *listChannel = Channels.First(); listChannel; listChannel = Channels.Next( listChannel ) ) {

#line 39 "channels_widget.ecpp"
#endif

#line 40 "channels_widget.ecpp"
		if ( listChannel->GroupSep() || *listChannel->Name() == '\0' )

#line 41 "channels_widget.ecpp"
			continue;

#line 42 "channels_widget.ecpp"


#line 43 "channels_widget.ecpp"
		std::string listChannelId = *listChannel->GetChannelID().ToString();

  reply.out() << _tntChunks[5]; // \t\t<option value="
#line 44 "channels_widget.ecpp"
  if ( channelid )
    reply.sout() <<  *listChannel->GetChannelID().ToString() ;
#line 44 "channels_widget.ecpp"
  if ( !channelid )
    reply.sout() <<  std::to_string(listChannel->Number()) ;
  reply.out() << _tntChunks[6]; // "
#line 44 "channels_widget.ecpp"
 reply.out() << ( listChannelId == selected ? " selected=\"selected\"" : "" ); 
  reply.out() << _tntChunks[7]; // >
#line 44 "channels_widget.ecpp"
  reply.sout() << ( std::to_string(listChannel->Number()) );
  reply.out() << _tntChunks[8]; // : 
#line 44 "channels_widget.ecpp"
  reply.sout() << ( listChannel->Name() );
  reply.out() << _tntChunks[9]; // </option>\n
#line 45 "channels_widget.ecpp"
	}

  reply.out() << _tntChunks[10]; // </select>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
