////////////////////////////////////////////////////////////////////////
// schedule.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.schedule")

// <%pre>
#line 1 "schedule.ecpp"


#include <livefeatures.h>
#include <setup.h>
#include <tools.h>
#include <epg_events.h>
#include <timers.h>
#include <recman.h>


#include <vdr/config.h>


using namespace vdrlive;




#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class channel_selection_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        channel_selection_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    channel_selection_type channel_selection;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("schedule");

static const char* rawData = "\230\000\000\000\231\000\000\000\232\000\000\000\007\001\000\000\022\001\000\000\025\001"
  "\000\000_\001\000\000\245\001\000\000\250\001\000\000\300\001\000\000\303\001\000\000\305\001\000\000\377\001\000\000"
  ")\002\000\0007\002\000\000^\002\000\000\200\002\000\000\242\002\000\000\310\002\000\000\312\002\000\000\327\002\000"
  "\000\015\003\000\000\020\003\000\000\023\003\000\000\"\003\000\000.\003\000\000c\003\000\000d\003\000\000e\003\000"
  "\000\302\003\000\000\334\003\000\000\361\003\000\000\367\003\000\000\375\003\000\000\003\004\000\000Q\004\000\000\231"
  "\004\000\000\247\004\000\000\n\n\n<html>\n\t<head>\n\t\t<meta name=\"viewport\" content=\"width=device-width, initial"
  "-scale=1\" />\n\t\t<title>VDR Live - </title>\n\t\t\n\t\t\n\t\t<script type=\"text/javascript\" src=\"js/live/createH"
  "tml.js\"></script>\n\t\t\n\t</head>\n\t<body onload=\"adjustHeader()\" onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t"
  "<div class=\"inhalt\">\n\t\t\t.\n\t\t<table class=\"listing\" cellspacing=\"0\" cellpadding=\"0\">\n\t\t\t\t<tr class"
  "=\"spacer\">\n\t\t\t\t\t<td colspan=\"\"/>\n\t\t\t\t</tr>\n\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t<td colspan=><div c"
  "lass=\"boxheader\"><div><div></div></div></div></td>\n\t\t\t\t</tr>\n<script>\n  document.write(eventString(, ))\n</s"
  "cript>\n  <script>\n    document.write(existingRecordingString(, \"\", ))\n  </script>\n\t\t\t</table>\n\t\t</div>\n"
  "\t</body>\n<script>imgLoad()</script>\n</html>\n\n\n<form action=\"schedule.html\" method=\"get\" id=\"channels\">\n "
  "  <span>\n     <label for=\"channel\">:&nbsp;<span class=\"bold\"></span></label>\n     \n     \n     \n     \n   </s"
  "pan>\n</form>\n<span class=\"sep\">|</span>\n<a href=\"schedule.html\?channel=\">\302\253 Prev</a>\n<span class=\"sep"
  "\">|</span>\n<a href=\"schedule.html\?channel=\">Next \302\273</a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    channel_selection(*this, "channel_selection")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("schedule " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
int channel = qparam.get< int >("channel", ( -1));
  // </%args>

#line 23 "schedule.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 28 "schedule.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_SHARED_VAR(cChannel*, Channel, ());   // <%request> cChannel* Channel
  _tnt_ignore_unused<Channel_type>(Channel);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 31 "schedule.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

#line 34 "schedule.ecpp"

	pageTitle = trVDR("Schedule");

bool display_pictures = !(LiveSetup().GetTvscraperImageDir().empty());

#if VDRVERSNUM < 20301
	cSchedulesLock schedulesLock;
	cSchedules const* schedules = cSchedules::Schedules( schedulesLock );

	ReadLock channelsLock( Channels );
	if ( !channelsLock )
		throw HtmlError( tr("Couldn't aquire access to channels, please try again later.") );
#endif

	// cChannel* Channel; (see %request above)
	if ( channel > 0 ) {
#if VDRVERSNUM >= 20301
		LOCK_CHANNELS_READ;
		Channel = (cChannel *)Channels->GetByNumber( channel );
#else
		Channel = Channels.GetByNumber( channel );
#endif
	}
	else {
#if VDRVERSNUM >= 20301
		LOCK_CHANNELS_READ;
#endif
		if (cDevice::CurrentChannel()) {
#if VDRVERSNUM >= 20301
			Channel = (cChannel *)Channels->GetByNumber(cDevice::CurrentChannel());
#else
			Channel = Channels.GetByNumber(cDevice::CurrentChannel());
#endif
		}
		else {
#if VDRVERSNUM >= 20301
			Channel = (cChannel *)Channels->Get( Channels->GetNextNormal( -1 ) );
#else
			Channel = Channels.Get( Channels.GetNextNormal( -1 ) );
#endif
		}
	}
	if ( Channel == 0 )
		throw HtmlError( tr("Couldn't find channel or no channels available. Maybe you mistyped your request?") );

	cSchedule const* Schedule;
#if VDRVERSNUM >= 20301
	{
		LOCK_SCHEDULES_READ;
		Schedule = Schedules->GetSchedule( (const cChannel *)Channel );
	}
#else
	Schedule = schedules->GetSchedule( Channel );
#endif

  // <& pageelems.doc_type ...
  { 
#line 89 "schedule.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 89 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n<html>\n\t<head>\n\t\t<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR Live - 
#line 93 "schedule.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[3]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 94 "schedule.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 94 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 95 "schedule.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 95 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t<script type="text/javascript" src="js/live/createHtml.js"></script>\n\t\t
  // <& pageelems.create_html_js ...
  { 
#line 97 "schedule.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 97 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 100 "schedule.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 100 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n\t\t
  // <& menu ...
  { 
#line 101 "schedule.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 101 "schedule.ecpp"
    _tnt_cq5.add( "active", ("schedule"));
#line 101 "schedule.ecpp"
    _tnt_cq5.add( "component", ("schedule.channel_selection"));
#line 101 "schedule.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[8]; // \n\t\t<div class="inhalt">\n
#line 103 "schedule.ecpp"

	if ( Schedule == 0 ) {

  reply.out() << _tntChunks[9]; // \t\t\t
#line 106 "schedule.ecpp"
  reply.sout() << ( tr("No schedules available for this channel") );
  reply.out() << _tntChunks[10]; // .\n
#line 107 "schedule.ecpp"

	}
	else {

  reply.out() << _tntChunks[11]; // \t\t<table class="listing" cellspacing="0" cellpadding="0">\n
#line 112 "schedule.ecpp"

		std::string current_day = "";
		const cEvent* PresentEvent = Schedule->GetPresentEvent();
		time_t now = time(NULL) - ::Setup.EPGLinger * 60;
                RecordingsItemPtr recItem;
                bool recItemFound;
    cLargeString epg_item("epg_item", 1000);
#if VDRVERSNUM >= 20301
		for (const cEvent *Event = (cEvent *)Schedule->Events()->First(); Event; Event = (cEvent *)Schedule->Events()->Next(Event)) {
#else
		for (const cEvent *Event = Schedule->Events()->First(); Event; Event = Schedule->Events()->Next(Event)) {
#endif
			if (Event->EndTime() <= now && Event != PresentEvent) continue;

			epg_item.clear();
			recItemFound = appendEpgItem(epg_item, recItem, Event, Channel, false);
			EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(Channel, Event);
			std::string day(epgEvent->StartTime(tr("%A, %b %d %Y")));

			bool lastEventCurrentDay = false;
			{
#if VDRVERSNUM >= 20301
				cEvent* NextEvent = (cEvent *)Schedule->Events()->Next(Event);
#else
				cEvent* NextEvent = Schedule->Events()->Next(Event);
#endif
				if (!NextEvent) {
					lastEventCurrentDay = true;
				}
				else {
					std::string nday(NextEvent->StartTime() ? FormatDateTime(tr("%A, %b %d %Y"), NextEvent->StartTime()) : "");
					lastEventCurrentDay = (day != nday);
				}
			}

			int col_span = 3;
			if (display_pictures) col_span++;
			if (current_day != day) {
				if (current_day != "") {

  reply.out() << _tntChunks[12]; // \t\t\t\t<tr class="spacer">\n\t\t\t\t\t<td colspan="
#line 153 "schedule.ecpp"
  reply.sout() << (col_span);
  reply.out() << _tntChunks[13]; // "/>\n\t\t\t\t</tr>\n
#line 155 "schedule.ecpp"

				}

  reply.out() << _tntChunks[14]; // \t\t\t\t<tr class="head">\n\t\t\t\t\t<td colspan=
#line 159 "schedule.ecpp"
  reply.sout() << (col_span);
  reply.out() << _tntChunks[15]; // ><div class="boxheader"><div><div>
#line 159 "schedule.ecpp"
  reply.sout() << ( day );
  reply.out() << _tntChunks[16]; // </div></div></div></td>\n\t\t\t\t</tr>\n
#line 161 "schedule.ecpp"

				current_day = day;
			}

  reply.out() << _tntChunks[17]; // <script>\n  document.write(eventString(
#line 166 "schedule.ecpp"
  reply.sout() << ((lastEventCurrentDay && !recItemFound)?"1":"0");
  reply.out() << _tntChunks[18]; // , 
#line 166 "schedule.ecpp"
  reply.out() << ( epg_item.c_str() );
  reply.out() << _tntChunks[19]; // ))\n</script>\n
#line 168 "schedule.ecpp"

if(recItemFound) {
  epg_item.clear();
  recItem->AppendAsJSArray(epg_item, true);

  reply.out() << _tntChunks[20]; //   <script>\n    document.write(existingRecordingString(
#line 174 "schedule.ecpp"
  reply.sout() << (col_span - 2);
  reply.out() << _tntChunks[21]; // , "
#line 174 "schedule.ecpp"
  if ( lastEventCurrentDay )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[22]; // ", 
#line 174 "schedule.ecpp"
  reply.out() << (epg_item.c_str());
  reply.out() << _tntChunks[23]; // ))\n  </script>\n
#line 176 "schedule.ecpp"
 }  // if rec item found
		}  // loop over all events

  reply.out() << _tntChunks[24]; // \t\t\t</table>\n
#line 180 "schedule.ecpp"

	}

  reply.out() << _tntChunks[25]; // \t\t</div>\n\t</body>\n<script>imgLoad()</script>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[26]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[27]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::channel_selection_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("schedule::channel_selection " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 23 "schedule.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 28 "schedule.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_SHARED_VAR(cChannel*, Channel, ());   // <%request> cChannel* Channel
  _tnt_ignore_unused<Channel_type>(Channel);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[28]; // <form action="schedule.html" method="get" id="channels">\n   <span>\n     <label for="channel">
#line 192 "schedule.ecpp"
  reply.sout() << ( tr("Channel") );
  reply.out() << _tntChunks[29]; // :&nbsp;<span class="bold">
#line 192 "schedule.ecpp"
  reply.sout() << ( std::to_string(Channel->Number()) );
  reply.out() << _tntChunks[30]; // </span></label>\n     
  // <& channels_widget ...
  { 
#line 193 "schedule.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 193 "schedule.ecpp"
    _tnt_cq6.add( "name", ("channel"));
#line 193 "schedule.ecpp"
    _tnt_cq6.add( "onchange", ("document.forms.channels.submit()"));
#line 193 "schedule.ecpp"
    _tnt_cq6.add( "selected", (Channel ? *Channel->GetChannelID().ToString() : ""));
#line 193 "schedule.ecpp"
    callComp(tnt::Compident(std::string(), "channels_widget"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[31]; // \n     
  // <& pageelems.ajax_action_href ...
  { 
#line 194 "schedule.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 194 "schedule.ecpp"
    _tnt_cq7.add( "action", "switch_channel");
#line 194 "schedule.ecpp"
    _tnt_cq7.add( "alt", "");
#line 194 "schedule.ecpp"
    _tnt_cq7.add( "image", "zap.png");
#line 194 "schedule.ecpp"
    _tnt_cq7.add( "param", (Channel->GetChannelID()));
#line 194 "schedule.ecpp"
    _tnt_cq7.add( "tip", (tr("Switch to this channel.")));
#line 194 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[32]; // \n     
  // <& pageelems.hls_channel ...
  { 
#line 195 "schedule.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 195 "schedule.ecpp"
    _tnt_cq8.add( "channelId", (Channel->GetChannelID()));
#line 195 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[33]; // \n     
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 196 "schedule.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 196 "schedule.ecpp"
    _tnt_cq9.add( "channelId", (Channel->GetChannelID()));
#line 196 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[34]; // \n   </span>\n</form>\n<span class="sep">|</span>\n<a href="schedule.html\?channel=
#line 200 "schedule.ecpp"
  reply.sout() << ( std::max(0, ((int)Channel->Number() - 1)) );
  reply.out() << _tntChunks[35]; // ">\302\253 Prev</a>\n<span class="sep">|</span>\n<a href="schedule.html\?channel=
#line 202 "schedule.ecpp"
  reply.sout() << ( (Channel->Number() + 1) );
  reply.out() << _tntChunks[36]; // ">Next \302\273</a>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
