////////////////////////////////////////////////////////////////////////
// timers.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.timers")

// <%pre>
#line 1 "timers.ecpp"


#include <timers.h>
#include <tools.h>
#include <setup.h>
#include <epg_events.h>
#include <timerconflict.h>
#include <livefeatures.h>
#include <users.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class timer_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        timer_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    timer_actions_type timer_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("timers");

static const char* rawData = "\000\001\000\000m\001\000\000x\001\000\000{\001\000\000\301\001\000\000\304\001\000\000"
  "\334\001\000\000\340\001\000\000\341\001\000\000\034\002\000\000[\002\000\000\267\002\000\000\206\003\000\000\263\003"
  "\000\000\340\003\000\000\015\004\000\000:\004\000\000g\004\000\000\251\005\000\000\312\005\000\000\326\005\000\000"
  "\337\005\000\000\374\005\000\0005\006\000\0007\006\000\000W\006\000\000\177\006\000\000\201\006\000\000\235\006\000"
  "\000\305\006\000\000\307\006\000\000\343\006\000\000\000\007\000\000\006\007\000\000\007\007\000\000#\007\000\000,"
  "\007\000\000R\007\000\000l\007\000\000\253\007\000\000\306\007\000\000\356\007\000\000\372\007\000\000,\010\000\000."
  "\010\000\000>\010\000\000\134\010\000\000{\010\000\000\225\010\000\000\236\010\000\000\324\010\000\000\326\010\000"
  "\000\003\t\000\000\"\t\000\000<\t\000\000E\t\000\000`\t\000\000\206\t\000\000\207\t\000\000\210\t\000\000\242\t\000"
  "\000\247\t\000\000\340\t\000\000\345\t\000\000\n<html>\n\t<head>\n\t\t<meta name=\"viewport\" content=\"width=device-"
  "width, initial-scale=1\" />\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t</head>\n\t<body onload=\"adjustHeader()\""
  " onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t\t\n\t\t\t<table class=\"listing\" cells"
  "pacing=\"0\" cellpadding=\"0\">\n\t\t\t\t\t\t<tr class=\"spacer\">\n\t\t\t\t\t\t\t<td colspan=\"8\"/>\n\t\t\t\t\t\t</"
  "tr>\n\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t<td colspan=\"10\">\n\t\t\t\t\t\t<div class=\"boxheader\"><div><div>\n\t"
  "\t\t\t\t\t\t\n\t\t\t\t\t\t</div></div></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class=\"description\">\n\t"
  "\t\t\t\t<td class=\"leftcol\"><img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t"
  "\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><"
  "div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><div class="
  "\"withmargin\"></div></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td class=\"action\"><img "
  "src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t<td class=\"action\"><img src="
  "\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t<td class=\"action rightcol\"><img"
  " src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t</tr>\n\t\t\t\t<tr>\n\n\t\t\t\t"
  "<td class=\"leftcol \"><img src=\"\" alt=\"\" ></img></td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"><a hre"
  "f=\"schedule.html\?channel=\"></a></div></td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin nowrap\" title=\"\"><"
  "/div></td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin nowrap\" title=\"\"></div></td>\n\t\t\t\t\t<td class=\""
  "\"><div class=\"withmargin\"><a\n\t\t\t\t\t\t\n\t\t\t\t\t\tclass=\"apopup\" title=\"\"\n\t\t\t\t\t\t></a></div>\n\t\t"
  "\t\t\t</td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"></div></td>\n                                        "
  "<td class=\"\"><div class=\"withmargin\">\n                                        </div></td>\n\t\t\t\t\t<a href=\"e"
  "dit_searchtimer.html\?searchtimerid=\"></a></div></td>\n\t\t\t\t        <td class=\"action \"><a href=\"timers.html\?"
  "timerid=&action=toggle\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t                <td class=\"action \"></td>\n"
  "\t\t\t\t        <td class=\"action rightcol \"><a href=\"timers.html\?timerid=&action=delete\"><img src=\"\" alt=\"\""
  " ></img></a></td>\n\t\t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n\n\n<a href=\"edit_timer.html\"></a"
  ">\n<span class=\"sep\">|</span>\n<a href=\"timerconflicts.html\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    timer_actions(*this, "timer_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string timerid = qparam.get< std::string >("timerid");
std::string action = qparam.get< std::string >("action");
  // </%args>

#line 20 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 23 "timers.ecpp"
  typedef const cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(const cTimer*, timer, ());   // <%request> const cTimer* timer
  _tnt_ignore_unused<timer_type>(timer);
#line 24 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(TimerConflictNotifier, timerNotifier, ());   // <%request> TimerConflictNotifier timerNotifier
  _tnt_ignore_unused<timerNotifier_type>(timerNotifier);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 27 "timers.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

	pageTitle = trVDR("Timers");

	cMutexLock timersLock( &LiveTimerManager() );
	SortedTimers& timers = LiveTimerManager().GetTimers();

	timer = 0;
	if ( !timerid.empty() ) {
		std::string tId = SortedTimers::DecodeDomId(timerid);
//		dsyslog("live: DEBUG: TIMER: tId = %s", tId.c_str());
		timer = timers.GetByTimerId(tId);
		if ( timer == 0 )
			throw HtmlError( tr("Couldn't find timer. Maybe you mistyped your request?") );
		if (action == "delete") {
			if (!cUser::CurrentUserHasRightTo(UR_DELTIMERS))
				throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
//                        dsyslog("live: timers.ecpp timer->Id() %d", timer->Id());
//                        dsyslog("live: timers.ecpp timer->Remote() %s", timer->Remote());
			LiveTimerManager().DelTimer(timer->Id(), timer->Remote());
			timerNotifier.SetTimerModification();
			return reply.redirect("timers.html");
		}
		if (action == "toggle") {
			LiveTimerManager().ToggleTimerActive(timer->Id(), timer->Remote());
			timerNotifier.SetTimerModification();
			return reply.redirect("timers.html");
		}
	}

	std::string previousDay = "";

  // <& pageelems.doc_type ...
  { 
#line 60 "timers.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 60 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n\t<head>\n\t\t<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR-Live - 
#line 64 "timers.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 65 "timers.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 65 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 66 "timers.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 66 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 69 "timers.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 69 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n\t\t
  // <& menu ...
  { 
#line 70 "timers.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 70 "timers.ecpp"
    _tnt_cq4.add( "active", ("timers"));
#line 70 "timers.ecpp"
    _tnt_cq4.add( "component", ("timers.timer_actions"));
#line 70 "timers.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t<div class="inhalt">\n
#line 72 "timers.ecpp"

		#ifdef DEBUG_LOCK
                        dsyslog("live: pages/timers.ecpp LOCK_TIMERS_READ");
                #endif
                        const char *lf;
                        if (LiveSetup().GetUseAjax()) lf = "<br/>";
                        else lf = "&#13;";
		        LOCK_TIMERS_READ;
                        cSortedTimers sortedTimers(Timers);
			if (sortedTimers.Size() == 0) {

  reply.out() << _tntChunks[6]; // \t\t\t\t
#line 83 "timers.ecpp"
  reply.sout() << ( tr("No timer defined") );
  reply.out() << _tntChunks[7]; // \n
#line 84 "timers.ecpp"
			} else {

  reply.out() << _tntChunks[8]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n
#line 86 "timers.ecpp"

				// output of the timer list:
                                for (int i = 0; i < sortedTimers.Size(); i++) {
                                        const cTimer *timer = sortedTimers[i];
	                 		EpgInfoPtr epgEvent = 0;
					std::string longDescription;
					std::string searchTimName;
					std::string searchTimId;

					if (timer->Event())
					{
                                          epgEvent = EpgEvents::CreateEpgInfo(timer->Channel(), timer->Event());
                                          bool truncated = false;
                                          longDescription  = StringEscapeAndBreak(SortedTimers::GetTimerInfo(*timer), lf);
                                          longDescription += LiveSetup().GetUseAjax()?"<hr>":lf;
					  longDescription += StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), LiveSetup().GetMaxTooltipChars(), truncated), lf);
					  if (truncated) longDescription += "...";
                                          searchTimName = SortedTimers::SearchTimerInfo(*timer, "searchtimer");
                                          searchTimId = SortedTimers::SearchTimerInfo(*timer, "s-id");
                                          if (searchTimName.empty() && searchTimId.empty() ) searchTimName = SortedTimers::TvScraperTimerInfo(*timer);
					}
					std::string currentDay = SortedTimers::GetTimerDays(timer);
                                        const cTimer *nextTimer =  NULL;
                                        if (i < (sortedTimers.Size() - 1)) nextTimer = sortedTimers[i + 1];
					bool bottom = false;
					if (i == sortedTimers.Size() - 1) bottom = true;
					else {
						std::string nextDay = SortedTimers::GetTimerDays(nextTimer);
						bottom = (currentDay != nextDay);
					}
					if (previousDay != currentDay) {
						if (!previousDay.empty()) {

  reply.out() << _tntChunks[9]; // \t\t\t\t\t\t<tr class="spacer">\n\t\t\t\t\t\t\t<td colspan="8"/>\n\t\t\t\t\t\t</tr>\n
#line 122 "timers.ecpp"

						}
						previousDay = currentDay;

  reply.out() << _tntChunks[10]; // \t\t\t\t<tr class="head">\n\t\t\t\t\t<td colspan="10">\n\t\t\t\t\t\t<div class="boxheader"><div><div>\n\t\t\t\t\t\t\t
#line 129 "timers.ecpp"
  reply.sout() << ( currentDay );
  reply.out() << _tntChunks[11]; // \n\t\t\t\t\t\t</div></div></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class="description">\n\t\t\t\t\t<td class="leftcol"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 135 "timers.ecpp"
  reply.sout() << ( trVDR("Channel") );
  reply.out() << _tntChunks[12]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 136 "timers.ecpp"
  reply.sout() << ( trVDR("Start") );
  reply.out() << _tntChunks[13]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 137 "timers.ecpp"
  reply.sout() << ( trVDR("Stop") );
  reply.out() << _tntChunks[14]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 138 "timers.ecpp"
  reply.sout() << ( trVDR("File") );
  reply.out() << _tntChunks[15]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 139 "timers.ecpp"
  reply.sout() << ( trVDR("Record on") );
  reply.out() << _tntChunks[16]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 140 "timers.ecpp"
  reply.sout() << ( tr("Searchtimer") );
  reply.out() << _tntChunks[17]; // </div></td>\n\t\t\t\t\t<td class="action"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t<td class="action"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t<td class="action rightcol"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t</tr>\n
#line 145 "timers.ecpp"

					}
					std::string timerStateImg = "transparent.png";
					std::string timerStateHint;
					if (timer->Recording()) {
						timerStateImg = "arrow_rec.gif";
						timerStateHint = tr("Timer is recording.");
					}
					else if (timer->Flags() & tfActive) {
						timerStateImg = "arrow.png";
						timerStateHint = tr("Timer is active.");
					}

  reply.out() << _tntChunks[18]; // \t\t\t\t<tr>\n\n\t\t\t\t<td class="leftcol 
#line 160 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[19]; // "><img src="
#line 160 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", timerStateImg) );
  reply.out() << _tntChunks[20]; // " alt="" 
#line 160 "timers.ecpp"
 if (!timerStateHint.empty()) { 
  // <& tooltip.hint ...
  { 
#line 160 "timers.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 160 "timers.ecpp"
    _tnt_cq5.add( "text", (timerStateHint));
#line 160 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
#line 160 "timers.ecpp"
 } 
  reply.out() << _tntChunks[21]; // ></img></td>\n\t\t\t\t\t<td class="
#line 161 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[22]; // "><div class="withmargin"><a href="schedule.html\?channel=
#line 161 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Number());
  reply.out() << _tntChunks[23]; // ">
#line 161 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Name() );
  reply.out() << _tntChunks[24]; // </a></div></td>\n\t\t\t\t\t<td class="
#line 162 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[25]; // "><div class="withmargin nowrap" title="
#line 162 "timers.ecpp"
  reply.out() << (longDescription);
  reply.out() << _tntChunks[26]; // ">
#line 162 "timers.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StartTime()) );
  reply.out() << _tntChunks[27]; // </div></td>\n\t\t\t\t\t<td class="
#line 163 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[28]; // "><div class="withmargin nowrap" title="
#line 163 "timers.ecpp"
  reply.out() << (longDescription);
  reply.out() << _tntChunks[29]; // ">
#line 163 "timers.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StopTime()) );
  reply.out() << _tntChunks[30]; // </div></td>\n\t\t\t\t\t<td class="
#line 164 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[31]; // "><div class="withmargin"><a\n
#line 165 "timers.ecpp"
 if(epgEvent) { 
  reply.out() << _tntChunks[32]; // \t\t\t\t\t\t
  // <& tooltip.display ...
  { 
#line 166 "timers.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 166 "timers.ecpp"
    _tnt_cq6.add( "domId", (epgEvent->Id()));
#line 166 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[33]; // \n
#line 167 "timers.ecpp"
 } 
  reply.out() << _tntChunks[34]; // \t\t\t\t\t\tclass="apopup" title="
#line 168 "timers.ecpp"
  reply.out() << (longDescription);
  reply.out() << _tntChunks[35]; // "\n\t\t\t\t\t\t>
#line 169 "timers.ecpp"
  reply.sout() << ( timer->File() );
  reply.out() << _tntChunks[36]; // </a></div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class="
#line 171 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[37]; // "><div class="withmargin">
#line 171 "timers.ecpp"
  reply.sout() << ( timer->Local()?trVDR(" "):timer->Remote() );
  reply.out() << _tntChunks[38]; // </div></td>\n                                        <td class="
#line 172 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[39]; // "><div class="withmargin">\n
#line 173 "timers.ecpp"
					if ( !timer->Local() || searchTimId.empty() ) {

  reply.out() << _tntChunks[40]; //                                         
#line 174 "timers.ecpp"
  reply.sout() << ( searchTimName );
  reply.out() << _tntChunks[41]; // </div></td>\n
#line 175 "timers.ecpp"
					} else {

  reply.out() << _tntChunks[42]; // \t\t\t\t\t<a href="edit_searchtimer.html\?searchtimerid=
#line 176 "timers.ecpp"
  reply.sout() << ( searchTimId );
  reply.out() << _tntChunks[43]; // ">
#line 176 "timers.ecpp"
  reply.sout() << ( searchTimName );
  reply.out() << _tntChunks[44]; // </a></div></td>\n
#line 177 "timers.ecpp"
					}

  reply.out() << _tntChunks[45]; // \t\t\t\t        <td class="action 
#line 178 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[46]; // "><a href="timers.html\?timerid=
#line 178 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << _tntChunks[47]; // &action=toggle"><img src="
#line 178 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", (timer->Flags() & tfActive) ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[48]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 178 "timers.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 178 "timers.ecpp"
    _tnt_cq7.add( "text", (tr("Toggle timer active/inactive")));
#line 178 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[49]; // ></img></a></td>\n\t\t\t                <td class="action 
#line 179 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[50]; // ">
  // <& pageelems.edit_timer ...
  { 
#line 179 "timers.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 179 "timers.ecpp"
    _tnt_cq8.add( "timerId", (timers.GetTimerId(*timer)));
#line 179 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[51]; // </td>\n\t\t\t\t        <td class="action rightcol 
#line 180 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[52]; // "><a href="timers.html\?timerid=
#line 180 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << _tntChunks[53]; // &action=delete"><img src="
#line 180 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[54]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 180 "timers.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 180 "timers.ecpp"
    _tnt_cq9.add( "text", (tr("Delete timer")));
#line 180 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[55]; // ></img></a></td>\n\t\t\t\t</tr>\n
#line 182 "timers.ecpp"

				}
			}

  reply.out() << _tntChunks[56]; // \t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[57]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[58]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::timer_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers::timer_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 23 "timers.ecpp"
  typedef const cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(const cTimer*, timer, ());   // <%request> const cTimer* timer
  _tnt_ignore_unused<timer_type>(timer);
#line 24 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(TimerConflictNotifier, timerNotifier, ());   // <%request> TimerConflictNotifier timerNotifier
  _tnt_ignore_unused<timerNotifier_type>(timerNotifier);
#line 20 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[59]; // <a href="edit_timer.html">
#line 193 "timers.ecpp"
  reply.sout() << ( tr("New timer") );
  reply.out() << _tntChunks[60]; // </a>\n
#line 194 "timers.ecpp"
 if ( LiveFeatures< features::epgsearch >().Recent() ) {

  reply.out() << _tntChunks[61]; // <span class="sep">|</span>\n<a href="timerconflicts.html">
#line 196 "timers.ecpp"
  reply.sout() << ( tr("Timer conflicts") );
  reply.out() << _tntChunks[62]; // </a>\n
#line 197 "timers.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

} // namespace
